%define name	courier-imap
%define version 4.1.1
%define release %mkrel 8

Name:		%{name}
Version:	%{version}
Release:	%{release}
Summary:	Courier-IMAP is an IMAP server that uses Maildirs
License:	GPL
Group:		System/Servers
URL:		http://www.courier-mta.org
Source0:	http://prdownloads.sourceforge.net/courier/%{name}-%{version}.tar.bz2
Source1:	%{name}.imapd-init
Source2:	%{name}.imapd-ssl-init
Source3:	%{name}.pop3d-init
Source4:	%{name}.pop3d-ssl-init
Patch0:		courier-imap-4.1.1-pam_service_name.diff
Requires:	courier-base = %{version}
Requires:	courier-authdaemon
Requires(pre):	rpm-helper
BuildRequires:	gdbm-devel
BuildRequires:	openssl-devel
BuildRequires:	courier-authlib-devel
BuildRequires:	courier-authdaemon
BuildRoot:	%{_tmppath}/%{name}-%{version}

%description
Courier-IMAP is an IMAP server for Maildir mailboxes. This package contains
the standalone version of the IMAP server that's included in the Courier
mail server package. This package is a standalone version for use with
other mail servers. Do not install this package if you intend to install
the full Courier mail server.  Install the Courier package instead.

%package -n courier-base
Summary:	Courier base files for POP and IMAP servers
Group:		System/Servers
Obsoletes:	maildirmake++

%description -n courier-base
This package contains the base files for POP and IMAP servers.

%package -n courier-pop
Summary:	Courier POP servers
Group:		System/Servers
Requires:	courier-base = %{version}
Requires:	courier-authdaemon
Requires(pre):	rpm-helper

%description -n courier-pop
This package contains the POP servers of the Courier-IMAP
server suite.

%prep
%setup -q
%patch0 -p1
chmod 644 maildir/README.sharedfolders.html imap/README.html


%build
%configure \
    --enable-unicode \
    --libexec=%{_libdir}/%{name} \
    --datadir=%{_datadir}/%{name} \
    --sysconfdir=%{_sysconfdir}/courier

%make

%check
%{__make} check

%install
rm -rf %{buildroot}
install -d -m 755 %{buildroot}%{_initrddir}
install -d -m 755 %{buildroot}%{_sysconfdir}/pam.d
%makeinstall_std

# delete upstream init scripts and install custom one
rm -f  %{buildroot}%{_libdir}/%{name}/*.rc
install -m 755 %{SOURCE1} %{buildroot}%{_initrddir}/courier-imapd
install -m 755 %{SOURCE2} %{buildroot}%{_initrddir}/courier-imapd-ssl
install -m 755 %{SOURCE3} %{buildroot}%{_initrddir}/courier-pop3d
install -m 755 %{SOURCE4} %{buildroot}%{_initrddir}/courier-pop3d-ssl
perl -pi -e 's|\@libdir\@|%{_libdir}|' %{buildroot}%{_initrddir}/*

# fix configuration
for file in %{buildroot}%{_sysconfdir}/courier/*.dist; do
    mv $file  %{buildroot}%{_sysconfdir}/courier/`basename $file .dist`
done
chmod 644 %{buildroot}%{_sysconfdir}/courier/imapd*
chmod 644 %{buildroot}%{_sysconfdir}/courier/pop3d*

# fix pam configuration
rm -f %{buildroot}%{_sysconfdir}/pam.d/*
cat > %{buildroot}%{_sysconfdir}/pam.d/courier-imap <<EOF
auth	required	pam_nologin.so
auth	include	system-auth
account	include	system-auth
session	include	system-auth
EOF
cat > %{buildroot}%{_sysconfdir}/pam.d/courier-pop3 <<EOF
auth	required	pam_nologin.so
auth	include	system-auth
account	include	system-auth
session	include	system-auth
EOF

# fix name conflict for doc files
cp imap/README imap/README.imap
cp rfc822/ChangeLog rfc822/ChangeLog.rfc822
cp unicode/README unicode/README.unicode

# Maildir
install -d -m 755 %{buildroot}%{_sysconfdir}/skel
(cd %{buildroot}%{_sysconfdir}/skel && %{buildroot}%{_bindir}/maildirmake Maildir)


cat > README.mdv << EOF
Mandriva RPM specific notes

Upgrade
-------
Upstream upgrade procedure consists of shipping new configuration files with
.dist suffix, then running sysconftool script to merge with current
configuration. This packages ships new configuration files with their final
name instead, wich will be saved by rpm as .rpmnew if original ones have been
modified, and run sysconftools script during upgrade automatically.

Init scripts
------------
Upstream init system consist of one unique init script, using values in
configuration files to select wich services to run. This package ships a
replacement init system, composed of four distincts standard services script
for each server, so as to use normal procedure (chkconfig command) to determine
which one to run. As a side-effect, the various *START variables in
configuration files have no effect.
EOF

# replace SSL certs configuration with our own
install -d -m 755 %{buildroot}%{_sysconfdir}/pki/tls
cat >  %{buildroot}%{_sysconfdir}/pki/tls/courier-imapd.cnf << EOF
[ req ]
default_bits            = 1024
encrypt_key             = no
prompt                  = no
distinguished_name      = req_dn
req_extensions          = req_ext

[ req_dn ]
commonName		= \$ENV::HOSTNAME
organizationalUnitName	= self-signed courier-imap cert
emailAddress		= root@\$ENV::HOSTNAME

[ req_ext ]
basicConstraints        = CA:FALSE
EOF
cat >  %{buildroot}%{_sysconfdir}/pki/tls/courier-pop3d.cnf << EOF
[ req ]
default_bits            = 1024
encrypt_key             = no
prompt                  = no
distinguished_name      = req_dn
req_extensions          = req_ext

[ req_dn ]
commonName		= \$ENV::HOSTNAME
organizationalUnitName	= self-signed courier-pop3 cert
emailAddress		= root@\$ENV::HOSTNAME

[ req_ext ]
basicConstraints        = CA:FALSE
EOF
rm -f %{buildroot}%{_sysconfdir}/courier/imapd.cnf
rm -f %{buildroot}%{_sysconfdir}/courier/pop3d.cnf
perl -pi \
    -e 's|TLS_CERTFILE=.*|TLS_CERTFILE=%{_sysconfdir}/pki/tls/private/courier-imapd.pem|'\
    %{buildroot}%{_sysconfdir}/courier/imapd-ssl
perl -pi \
    -e 's|TLS_CERTFILE=.*|TLS_CERTFILE=%{_sysconfdir}/pki/tls/private/courier-pop3d.pem|'\
    %{buildroot}%{_sysconfdir}/courier/pop3d-ssl

%post
# generate SSL cert if needed
if [ $1 = 1 ]; then
    openssl req -new -x509 -days 365 \
        -config %{_sysconfdir}/pki/tls/courier-imapd.cnf \
        -keyout %{_sysconfdir}/pki/tls/private/courier-imapd.pem \
        -out %{_sysconfdir}/pki/tls/certs/courier-imapd.pem
    # courier-imap requires cert and key in the same file
    cat %{_sysconfdir}/pki/tls/certs/courier-imapd.pem \
        >> %{_sysconfdir}/pki/tls/private/courier-imapd.pem
    # enforce strict perms
    chmod 600 %{_sysconfdir}/pki/tls/private/courier-imapd.pem
fi
if [ -f %{_sysconfdir}/courier/imapd.rpmnew ]; then
    %{_libdir}/courier-authlib/sysconftool %{_sysconfdir}/courier/imapd.rpmnew >/dev/null
fi
if [ -f %{_sysconfdir}/courier/imapd-ssl.rpmnew ]; then
    %{_libdir}/courier-authlib/sysconftool %{_sysconfdir}/courier/imapd-ssl.rpmnew >/dev/null
fi
%_post_service courier-imapd
%_post_service courier-imapd-ssl

%preun 
%_preun_service courier-imapd
%_preun_service courier-imapd-ssl

%post -n courier-pop
# generate SSL cert if needed
if [ $1 = 1 ]; then
    openssl req -new -x509 -days 365 \
        -config %{_sysconfdir}/pki/tls/courier-pop3d.cnf \
        -keyout %{_sysconfdir}/pki/tls/private/courier-pop3d.pem \
        -out %{_sysconfdir}/pki/tls/certs/courier-pop3d.pem
    # courier-pop requires cert and key in the same file
    cat %{_sysconfdir}/pki/tls/certs/courier-pop3d.pem \
        >> %{_sysconfdir}/pki/tls/private/courier-pop3d.pem
    # enforce strict perms
    chmod 600 %{_sysconfdir}/pki/tls/private/courier-pop3d.pem
fi
if [ -f %{_sysconfdir}/courier/pop3d.rpmnew ]; then
    %{_libdir}/courier-authlib/sysconftool %{_sysconfdir}/courier/pop3d.rpmnew >/dev/null
fi
if [ -f %{_sysconfdir}/courier/pop3d-ssl.rpmnew ]; then
    %{_libdir}/courier-authlib/sysconftool %{_sysconfdir}/courier/pop3d-ssl.rpmnew >/dev/null
fi
%_post_service courier-pop3d
%_post_service courier-pop3d-ssl

%preun -n courier-pop
%_preun_service courier-pop3d
%_preun_service courier-pop3d-ssl

%clean
rm -rf %{buildroot}

%files -n courier-base
%defattr(-,root,root)
%doc INSTALL INSTALL.html NEWS README README.mdv
%doc liblock/*.html
%doc maildir/README.* maildir/*.html
%doc rfc2045/*.html
%doc rfc822/ChangeLog.rfc822 rfc822/rfc822.html
%doc tcpd/README.* tcpd/*.html
%doc unicode/README.*
%doc maildir/maildirmake.html
%config(noreplace) %{_sysconfdir}/courier/quotawarnmsg.example
%config(noreplace) %{_sysconfdir}/courier/shared
%config(noreplace) %{_sysconfdir}/courier/shared.tmp
%config(noreplace) %{_sysconfdir}/skel/Maildir
%{_bindir}/maildirmake
%{_bindir}/deliverquota
%{_bindir}/couriertls
%{_bindir}/maildirkw
%{_bindir}/maildiracl
%{_sbindir}/sharedindexinstall
%{_sbindir}/sharedindexsplit
%{_mandir}/man1/maildirmake.1*
%{_mandir}/man1/couriertcpd.1*
%{_mandir}/man1/maildiracl.1*
%{_mandir}/man1/maildirkw.1*
%{_mandir}/man8/deliverquota.8*
%{_libdir}/%{name}

%files
%defattr(-,root,root)
%doc imap/BUGS imap/ChangeLog imap/README.* imap/*.html
%config(noreplace) %{_sysconfdir}/pam.d/courier-imap
%config(noreplace) %{_sysconfdir}/courier/imapd
%config(noreplace) %{_sysconfdir}/courier/imapd-ssl
%config(noreplace) %{_sysconfdir}/pki/tls/courier-imapd.cnf
%{_initrddir}/courier-imapd
%{_initrddir}/courier-imapd-ssl
%{_bindir}/imapd
%{_sbindir}/imaplogin
%{_sbindir}/mkimapdcert
%{_mandir}/man8/imapd.8*
%{_mandir}/man8/mkimapdcert.8*
%{_datadir}/%{name}/mkimapdcert

%files -n courier-pop
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/pam.d/courier-pop3
%config(noreplace) %{_sysconfdir}/courier/pop3d
%config(noreplace) %{_sysconfdir}/courier/pop3d-ssl
%config(noreplace) %{_sysconfdir}/pki/tls/courier-pop3d.cnf
%{_initrddir}/courier-pop3d
%{_initrddir}/courier-pop3d-ssl
%{_bindir}/pop3d
%{_sbindir}/pop3login
%{_sbindir}/mkpop3dcert
%{_mandir}/man8/mkpop3dcert.8*
%{_datadir}/%{name}/mkpop3dcert


%changelog
* Fri Dec 29 2006 Guillaume Rousse <guillomovitch@mandriva.org> 4.1.1-8mdv2007.1
+ Revision: 102596
- bump release
- use correct variable in correct script
- fix pam configuration file generation

* Mon Nov 13 2006 Frederic Crozat <fcrozat@mandriva.com> 4.1.1-7mdv2007.1
+ Revision: 83703
- Fix initscript to export configuration variable (Mdv bug #26942)
- Import courier-imap



* Tue Sep 19 2006 Guillaume Rousse <guillomovitch@mandriva.org> 4.1.1-6mdv2007.0
- fix pam configuration [fix #25923)
- network dependency in initscripts
- uncompress all additional sources
- revert previous cosmetic changes done without my consent

* Thu Sep 14 2006 Oden Eriksson <oeriksson@mandriva.com> 4.1.1-5mdv2007.0
- fix pam service name (P0) and some conflicts

* Wed Aug 30 2006 Guillaume Rousse <guillomovitch@mandriva.org> 4.1.1-4mdv2007.0
- fix config file merging in %post

* Wed Aug 30 2006 Guillaume Rousse <guillomovitch@mandriva.org> 4.1.1-3mdv2007.0
- handle SSL cert generation in %post

* Mon Jun 26 2006 Rafael Garcia-Suarez <rgarciasuarez@mandriva.com> 4.1.1-2mdv2007.0
- Add a Conflicts with cyrus-imapd (due to file /etc/pam.d/imap in both packages)

* Wed May 31 2006 Guillaume Rousse <guillomovitch@mandriva.org> 4.1.1-1mdv2007.0
- new version 
- fix initscripts (config and binary location #22715, status report)
- add Maildir in %_sysconfdir/skel, as there is no more automatic creation patch
- courier-base obsoletes maildirmake++

* Wed May 24 2006 Guillaume Rousse <guillomovitch@mandriva.org> 4.1.0-3mdk
- move files shared by pop and imap server into courier-base package
- fix requires
- fix config files perms
- buildrequires courier-authdaemon also, as configure check for tcplogger

* Tue May 16 2006 Guillaume Rousse <guillomovitch@mandriva.org> 4.1.0-2mdk
- minor initscript corrections
- fix pam configuration
- requires courier-authlib

* Mon Apr 17 2006 Guillaume Rousse <guillomovitch@mandrake.org> 4.1.0-1mdk
- new version
- no more distinct maildirmake package
- no more renaming of maildirmake command
- drop automatic maildir creation patch, didn't apply and too cumbersome
- disable buggy imap clients support
- enable test
- large spec cleanup
- replace upstream init scripts with standard mandriva ones
- README.mdv

* Tue Jan 24 2006 Oden Eriksson <oeriksson@mandriva.com> 3.0.8-10mdk
- rebuilt die to package loss

* Wed Nov 30 2005 Oden Eriksson <oeriksson@mandriva.com> 3.0.8-9mdk
- rebuilt against openssl-0.9.8a

* Sun Oct 30 2005 Oden Eriksson <oeriksson@mandriva.com> 3.0.8-8mdk
- rebuilt against MySQL-5.0.15

* Thu Sep 08 2005 Andreas Hasenack <andreas@mandriva.com> 3.0.8-7mdk
- rebuilt with openldap-2.3.x
- added overflow patch and workaround authmksock bug hit during %%install
  with long paths

* Wed May 11 2005 Buchan Milne <bgmilne@linux-mandrake.com> 3.0.8-6mdk
- Rebuild for postgresql-devel 8.0.2

* Sun Mar 06 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 3.0.8-5mdk
- added a conflict on the courier-authdaemond package
- this will be the last 3.x package, if you badly need it, grab it now
  and tuck it away. v4.x will be completely different. An upgrade from
  the 3.x rpm package to 4.x will probably not be possible.

* Tue Feb 08 2005 Buchan Milne <bgmilne@linux-mandrake.com> 3.0.8-4mdk
- rebuild for ldap2.2_7

* Fri Feb  4 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 3.0.8-3mdk
- rebuilt against new openldap libs

* Mon Jan 24 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 3.0.8-2mdk
- rebuilt against MySQL-4.1.x system libs

* Sun Sep 19 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 3.0.8-1mdk
- 3.0.8
- rediff P1

* Thu Aug 12 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 3.0.7-1mdk
- 3.0.7

* Thu Jul 29 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 3.0.6-1mdk
- 3.0.6

* Sun Jun 20 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 3.0.5-1mdk
- 3.0.5
- rediff P1

* Mon Jun 07 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 3.0.4-2mdk
- rebuilt with gcc v3.4.x

* Tue Jun 01 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 3.0.4-1mdk
- 3.0.4
- rediff P1

* Wed Mar 31 2004 Michael Scherer <misc@mandrake.org> 3.0.2-1mdk
- 3.0.2
- rediff patch #0
- rediff patch #1
 
* Mon Mar 29 2004 Michael Scherer <misc@mandrake.org> 2.1.2-3mdk
- fix automaildir patch ( #9290 )
 
* Mon Dec 29 2003 Michael Scherer <misc@mandrake.org> 2.1.2-2mdk
- add missing man pages ( vchkpw2userdb )
- clean BuildRequires 

* Sun Sep 14 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.1.2-1mdk
- 2.1.2
- fix invalid-build-requires
- fix explicit-lib-dependency
- rediffed the auto_maildir_creator patch

* Wed Aug 20 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.1.1-1mdk
- 2.1.1
- rediffed the auto_maildir_creator patch

* Mon Aug 18 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.1.0-1mdk
- 2.1.0
- rediffed the auto_maildir_creator patch
- added the new %{_bindir}/maildirkw command

* Wed Jul 16 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.0-1mdk
- 2.0.0
- rediffed the auto_maildir_creator patch

* Tue May 20 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.7.3-1mdk
- 1.7.3
- use the %%configure2_5x macro
- misc spec file fixes

* Mon Apr 14 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.7.1-1mdk
- 1.7.1
- added S2 & S3 from a mail from Carlo Contavalli
- feixed another way to apply the patch in S2
- misc spec file fixes

* Sun Feb 09 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.7.0-3mdk
- added P1 (obsoletes the requirement and should end the 
  thread about my controversial Maildir package (?))
- added S2 & S3

* Thu Feb 06 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.7.0-2mdk
- broke out the maildirmake command into a subpackage as maildirmake++
- require Maildir & maildirmake++

* Tue Jan 28 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.7.0-1mdk
- 1.7.0
- dont ship unused files
- misc spec file fixes

* Sun Jan 26 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.6.2-2mdk
- build release

* Tue Dec 31 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.6.2-1mdk
- 1.6.2

* Mon Dec 30 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.6.1-2mdk
- make the rpm magic work (duh!)
- fix P0
- misc spec file fixes

* Mon Dec 30 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.6.1-1mdk
- new version
- fix P0
- misc spec file fixes

* Fri Oct 25 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.6.0-1mdk
- new version
- %{_bindir}/deliverquota was missing from package (why?)
- added %{_bindir}/courier-imap-authdaemontest to the utils sub package
- make sure you read the "REALTIME FOLDER STATUS UPDATES" section in
  the "INSTALL" file (buildrequires fam-devel).
- misc spec file fixes

* Wed Sep 18 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.5.3-1mdk
- new version

* Sat Aug  3 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.5.2-1mdk
- new version

* Sun Jul  7 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.5.1-1mdk
- new version

* Mon Jun 24 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.5.0-1mdk
- new version

* Sun May 26 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.4.6-1mdk
- new version
- build with gcc 3.1

* Mon May  6 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.4.5-1mdk
- new version
- added "--without-authvchkpw" for now

* Sun Mar 24 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.4.3-3mdk
- added the utils sub package.
- added "--disable-root-check"

* Thu Mar 21 2002 Frederic Crozat <fcrozat@mandrakesoft.com> 1.4.3-2mdk
- Add --enable-workarounds-for-imap-client-bugs option (from Oden Eriksson)
- Remove make check as it won't work with option above

* Tue Mar 19 2002 Frederic Crozat <fcrozat@mandrakesoft.com> 1.4.3-1mdk
- Release 1.4.3
- Fix start script to call functions file
- Clean specfile
- Move courier files in separate 
  directories (%{couriersysconf}, %{courierdatadir},  %{courierlibdir})
- Remove profiles.d scripts, they are not useful at all
- Remove some conflicts in -pop package, they prevent installing the package...

* Thu Jan 24 2002 Alexander Skwar <ASkwar@DigitalProjects.com> 1.4.2-1mdk
- 1.4.2
- Make rpmlint a little happier by creating the ghost files in postins
  and by trimming the length of the lines in the description

* Thu Nov 29 2001 Alexander Skwar <ASkwar@Linux-Mandrake.com> 1.3.12.20011123-3md
- Make it really conflict with uw-imap
- Just like uw-imap, have it also Provides: imap-server
- Split POP stuff into a -pop subpackage, which Provides: pop, pop-server
- Add the warning shown when installing the RPM also to the description
- FIXME: There are still some problems with the maildrop-man package; maybe a full
  blown courier package containg the IMAP server, maildrop and SqWebMail should be
  done to fix this

* Wed Nov 28 2001 Alexander Skwar <ASkwar@Linux-Mandrake.com> 1.3.12.20011123-2mdk
- Make it conflict with imap (uw-imapd).  Todo: also have it conflict with cyrus
- Add a Provides: imap, so that other packages like php-imap can still be installed
  Hmm, this won't work.  uw-imapd needs to be renamed!
- Fix perms of %{datadir}/sysconftool
- Enable all unicode character sets
- Include pam files
- Make sure, that all (?) needed files are included
- Add a big, fat warning during post that ~/Maildir needs to be present for courier
  to work

* Tue Nov 27 2001 Alexander Skwar <ASkwar@Linux-Mandrake.com> 1.3.12.20011123-1mdk
- Basically rewrote the complete SPEC
- New release

* Sun Jan 28 2001 Vincent Danen <vdanen@mandrakesoft.com> 1.3.2-1mdk
- first Mandrake build
